% Sungmin Cho
% EE219A Homework #6 Problem (c)
% FE method to get an answer.
function C = calgal(file, NUM, method)

if (nargin < 2)
  NUM = 3
end

if (nargin < 3)
  method = 1
end

panels = readpanels(file);
[rows,cols,numpanels] = size(panels);

E_0 = 8.854187818E-12;

matrix = zeros(numpanels, numpanels);
RHS = zeros(numpanels,1);

for i=1:numpanels
  numverts = panels(1,1,i);
  panel = panels(2:numverts+1,:,i);

  for j=1:numpanels
    panel2 = panels(2:numverts+1,:,j);    
    x0 = panel2(1,1);
    y0 = panel2(1,2);
    x1 = panel2(3,1);
    y1 = panel2(3,2);
    col = dividepanel(x0,y0,x1,y1,NUM);
    [area, collocpt, Z, fss] = calcp(panel, col);
    res = area/(NUM*NUM)*sum(fss);
    matrix(i,j) = res;
  end
  RHS(i) = area; % barea == area in this case
end

if (method == 1)
  w = matrix \ RHS;
elseif (method == 2)
  w = tgcr2(matrix, RHS, 0.01, numpanels);
end

Q = w * area;
C = 4*pi*E_0*sum(Q);

